import random
import copy

import animation
import general

anims = ["small_kid_walk","small_girl_walk"]

initialized = False
def _get_animation_type(direction,model):
	global initialized
	global right_down,left_down,right_up,left_up
	
	if not initialized:
		right_down = [animation.AnimationType.create_by_name(anim,0.17,general.Vector2(83,111)) for anim in anims]
		left_down = [animtype.create_vertical_flipped() for animtype in right_down]
		right_up = right_down
		left_up = left_down
		initialized = True
	if direction.x == 1:
		return right_up[model]
	if direction.x == -1:
		return left_down[model]
	if direction.y == 1:
		return right_down[model]
	if direction.y == -1:
		return left_up[model]
	return None

class Person:
	possible_directions = [general.Vector2(1,0),general.Vector2(0,1),general.Vector2(-1,0),general.Vector2(0,-1)]
	def __init__(self,level_config):
		self.level_config = level_config
		self.model = random.randrange(len(anims))
		portal = random.choice(level_config.portals)
		self.position = copy.deepcopy(portal[0])
		self.direction = portal[1]
		self.animation = animation.AnimationInstance(_get_animation_type(self.direction,self.model))
		self.time_to_change = 2*self.level_config.person_walk_distance*random.random()
	
	def do_frame(self,time_delta):
		self.animation.do_frame(time_delta)
		self.position += self.direction * (time_delta*self.level_config.person_speed)
		self.time_to_change -= time_delta
		if self.time_to_change < 0:
			#it is a time for a change!
			self.time_to_change = self.level_config.person_walk_distance * random.random()
			self.direction = random.choice(Person.possible_directions)
			self.animation = animation.AnimationInstance(_get_animation_type(self.direction,self.model))
	
	def draw(self,target,pos_on_screen):
		pos_on_screen -= self.animation.animation_type.center
		image = self.animation.get_image()
		target.blit(image,(pos_on_screen.x,pos_on_screen.y))
	